/*
    xt_request_find_match
    by Jan Engelhardt <jengelh [at] gmx de>, 2006 - 2007

    Based upon linux-2.6.18.5/net/netfilter/x_tables.c:
    Copyright (C) 2006-2006 Harald Welte <laforge@netfilter.org>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.
*/
#include <linux/err.h>
#include <linux/netfilter_arp.h>
#include <linux/socket.h>
#include <linux/netfilter/x_tables.h>

/*
 * Yeah this code is sub-optimal, but the function is missing in
 * mainline so far. -jengelh
 */
static struct xt_match *xt_request_find_match_lo(int af, const char *name,
    u8 revision)
{
	static const char *const xt_prefix[] = {
		[AF_INET]  = "ip",
		[AF_INET6] = "ip6",
		[NF_ARP]   = "arp",
	};
	struct xt_match *match;

	match = try_then_request_module(xt_find_match(af, name, revision),
		"%st_%s", xt_prefix[af], name);
	if(IS_ERR(match) || match == NULL)
		return NULL;

	return match;
}

/* In case it goes into mainline, let this out-of-tree package compile */
#define xt_request_find_match xt_request_find_match_lo
